﻿
// MFCClassNetworkDlg.cpp: файл реализации
//

#include "pch.h"
#include "framework.h"
#include "MFCClassNetwork.h"
#include "MFCClassNetworkDlg.h"
#include "afxdialogex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif
#include "CSend.h"


//====================================================
// Описание работы классов и методов исходника на:
// https://www.interestprograms.ru
// Исходные коды программ и игр
// Автор исходных кодов Клочков Павел
//====================================================


// Диалоговое окно CAboutDlg используется для описания сведений о приложении

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// Данные диалогового окна
#ifdef AFX_DESIGN_TIME
	enum { IDD = IDD_ABOUTBOX };
#endif

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // поддержка DDX/DDV

// Реализация
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(IDD_ABOUTBOX)
{
	
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// Диалоговое окно CMFCClassNetworkDlg



CMFCClassNetworkDlg::CMFCClassNetworkDlg(CWnd* pParent /*=nullptr*/)
	: CDialogEx(IDD_MFCCLASSNETWORK_DIALOG, pParent)
	, m_MainSocket(this)
	, m_AcceptSocket(this)
	, m_Port(30000)
	, m_IP(_T("127.0.0.1"))
	, m_valueText(_T(""))
	, m_IsServer(FALSE)
	, m_IsClient(FALSE)
	, m_valueText2(_T(""))
	, m_valueArrayInts0(0)
	, m_valueArrayInts1(0)
	, m_valueArrayInts2(0)
	, m_valueArrayInts3(0)
	, m_valueArrayInts4(0)
	, m_valueArrayInts0_2(0)
	, m_valueArrayInts1_2(0)
	, m_valueArrayInts2_2(0)
	, m_valueArrayInts3_2(0)
	, m_valueArrayInts4_2(0)
	, m_valueBoolean(FALSE)
	, m_valueBoolean2(FALSE)
	, m_valueDouble(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	// Тест проверки утечки памяти
	// int* p = new int();
	
}

void CMFCClassNetworkDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);

	DDX_Check(pDX, IDC_RADIO_SERVER, m_IsServer);
	DDX_Check(pDX, IDC_RADIO_CLIENT, m_IsClient);
	DDX_Text(pDX, IDC_EDIT_TEXT, m_valueText);
	DDX_Text(pDX, IDC_EDIT_TEXT_2, m_valueText2);
	DDX_Check(pDX, IDC_CHECK_BOOLEAN, m_valueBoolean);
	DDX_Check(pDX, IDC_CHECK_BOOLEAN_2, m_valueBoolean2);
	DDX_Text(pDX, IDC_EDIT_ARRAYINTS0, m_valueArrayInts0);
	DDX_Text(pDX, IDC_EDIT_ARRAYINTS1, m_valueArrayInts1);
	DDX_Text(pDX, IDC_EDIT_ARRAYINTS2, m_valueArrayInts2);
	DDX_Text(pDX, IDC_EDIT_ARRAYINTS3, m_valueArrayInts3);
	DDX_Text(pDX, IDC_EDIT_ARRAYINTS4, m_valueArrayInts4);
	DDX_Text(pDX, IDC_EDIT_ARRAYINTS0_2, m_valueArrayInts0_2);
	DDX_Text(pDX, IDC_EDIT_ARRAYINTS1_2, m_valueArrayInts1_2);
	DDX_Text(pDX, IDC_EDIT_ARRAYINTS2_2, m_valueArrayInts2_2);
	DDX_Text(pDX, IDC_EDIT_ARRAYINTS3_2, m_valueArrayInts3_2);
	DDX_Text(pDX, IDC_EDIT_ARRAYINTS4_2, m_valueArrayInts4_2);
	DDX_Text(pDX, IDC_EDIT_IP, m_IP);
	DDX_Text(pDX, IDC_EDIT_PORT, m_Port);
	DDX_Text(pDX, IDC_EDIT_DOUBLE, m_valueDouble);
}

BEGIN_MESSAGE_MAP(CMFCClassNetworkDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_RADIO_SERVER, &CMFCClassNetworkDlg::OnBnClickedRadioServer)
	ON_BN_CLICKED(IDC_BUTTON_SEND, &CMFCClassNetworkDlg::OnBnClickedButtonSend)
	ON_BN_CLICKED(IDC_RADIO_CLIENT, &CMFCClassNetworkDlg::OnBnClickedRadioClient)
	ON_BN_CLICKED(IDC_BUTTON_CLOSE, &CMFCClassNetworkDlg::OnBnClickedButtonClose)
END_MESSAGE_MAP()


// Обработчики сообщений CMFCClassNetworkDlg

BOOL CMFCClassNetworkDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Добавление пункта "О программе..." в системное меню.

	// IDM_ABOUTBOX должен быть в пределах системной команды.
	//ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	//ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != nullptr)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Задает значок для этого диалогового окна.  Среда делает это автоматически,
	//  если главное окно приложения не является диалоговым
	SetIcon(m_hIcon, TRUE);			// Крупный значок
	SetIcon(m_hIcon, FALSE);		// Мелкий значок

	// TODO: добавьте дополнительную инициализацию

	return TRUE;  // возврат значения TRUE, если фокус не передан элементу управления
}

void CMFCClassNetworkDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// При добавлении кнопки свертывания в диалоговое окно нужно воспользоваться приведенным ниже кодом,
//  чтобы нарисовать значок.  Для приложений MFC, использующих модель документов или представлений,
//  это автоматически выполняется рабочей областью.

void CMFCClassNetworkDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // контекст устройства для рисования

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Выравнивание значка по центру клиентского прямоугольника
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Нарисуйте значок
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// Система вызывает эту функцию для получения отображения курсора при перемещении
//  свернутого окна.
HCURSOR CMFCClassNetworkDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}



void CMFCClassNetworkDlg::OnClose()
{
	// Место определения утечек памяти
	// Если ставить в деструкторах то идет двойное определение утечек,
	// плюс еще и сам дамп попадает под утечки.
	_CrtDumpMemoryLeaks();

	CDialogEx::OnClose();
}


void CMFCClassNetworkDlg::OnBnClickedRadioServer()
{
	UpdateData(TRUE);

	// Создавать сокет можно только если он нулевой.
	// Если сокет уже возвращает рабочий дескриптор выходим из метода.
	if (m_MainSocket.m_hSocket != INVALID_SOCKET)
	{
		CUtil::BeepError();

		int err = WSAGetLastError();
		CString s;
		s.Format(_T("Сокет уже инициализирован\n Error %d"), err);
		MessageBox(s);

		return;
	}

	if (m_MainSocket.Create(m_Port) == TRUE)
	{
		if (m_MainSocket.Listen() == TRUE)
		{
			SetWindowText(_T("Сервер на прослушивании..."));
		}
		else
		{
			CUtil::BeepError();
		}
	}
	else
	{
		CUtil::BeepError();
	}
}


// Метод-эхо метода класса CMySocket
void CMFCClassNetworkDlg::OnReceive(BOOL error)
{

	CMySocket* pSockReceive = NULL;

	if (m_IsServer == TRUE) pSockReceive = &m_AcceptSocket;

	if (m_IsClient == TRUE) pSockReceive = &m_MainSocket;


	if (pSockReceive != NULL)
	{

		CExchange stateReceive;
		int sizeReceive = sizeof(CExchange);

		pSockReceive->Receive(&stateReceive, sizeReceive);

		// --- Вывод полученных из сети данных на интерфейс ---

		// -- CExchange --
		m_valueText = stateReceive.m_Text;

		m_valueArrayInts0 = stateReceive.m_ArrayInts[0];
		m_valueArrayInts1 = stateReceive.m_ArrayInts[1];
		m_valueArrayInts2 = stateReceive.m_ArrayInts[2];
		m_valueArrayInts3 = stateReceive.m_ArrayInts[3];
		m_valueArrayInts4 = stateReceive.m_ArrayInts[4];

		m_valueBoolean = stateReceive.m_Boolean;

		m_valueDouble = stateReceive.m_Double;


		// -- CExchange::CAdd ---
		m_valueText2 = stateReceive.m_objectClass.m_Text;

		m_valueArrayInts0_2 = stateReceive.m_objectClass.m_ArrayInts[0];
		m_valueArrayInts1_2 = stateReceive.m_objectClass.m_ArrayInts[1];
		m_valueArrayInts2_2 = stateReceive.m_objectClass.m_ArrayInts[2];
		m_valueArrayInts3_2 = stateReceive.m_objectClass.m_ArrayInts[3];
		m_valueArrayInts4_2 = stateReceive.m_objectClass.m_ArrayInts[4];

		m_valueBoolean2 = stateReceive.m_objectClass.m_Boolean;

		UpdateData(FALSE);
	}
}


void CMFCClassNetworkDlg::OnAccept(BOOL error)
{
	// Только один клиент одновременно будет на связи.
	// При подключении нового клиента с предыдущим связь закрывается.
	// Это только для упрощения исходного кода.
	m_AcceptSocket.Close();


	// Если все в порядке добавим рабочий сокет в список 
	// подключенных рабочих сокетов.
	if (m_MainSocket.Accept(m_AcceptSocket) == TRUE)
	{
		SetWindowText(L"Сервер: клиент подключился!");
	}
	else
	{
		MessageBox(L"Ошибка подключения клиента!");
	}
}


void CMFCClassNetworkDlg::OnBnClickedButtonSend()
{
	// При вызове этой функции TRUE данные из оконных элементов диалога 
	// копируются в связанные с ними переменными.
	UpdateData(TRUE);

	CMySocket* pSockSend = NULL;
	
	if (m_IsServer == TRUE) pSockSend = &m_AcceptSocket;

	if (m_IsClient == TRUE) pSockSend = &m_MainSocket;


	if (pSockSend != NULL)
	{

		CExchange stateSend;
		int sizeSend = sizeof(CExchange);

		// --- Из элементов управления в переменные класса обмена данными по сети ---

		// -- CExchange --
		_tcsncpy_s(stateSend.m_Text, CExchange::m_lenText, m_valueText, _TRUNCATE);

		stateSend.m_ArrayInts[0] = m_valueArrayInts0;
		stateSend.m_ArrayInts[1] = m_valueArrayInts1;
		stateSend.m_ArrayInts[2] = m_valueArrayInts2;
		stateSend.m_ArrayInts[3] = m_valueArrayInts3;
		stateSend.m_ArrayInts[4] = m_valueArrayInts4;

		stateSend.m_Boolean = m_valueBoolean;

		stateSend.m_Double = m_valueDouble;


		// -- CExchange::CAdd --
		_tcsncpy_s(stateSend.m_objectClass.m_Text, CAdd::m_lenText, m_valueText2, _TRUNCATE);

		stateSend.m_objectClass.m_ArrayInts[0] = m_valueArrayInts0_2;
		stateSend.m_objectClass.m_ArrayInts[1] = m_valueArrayInts1_2;
		stateSend.m_objectClass.m_ArrayInts[2] = m_valueArrayInts2_2;
		stateSend.m_objectClass.m_ArrayInts[3] = m_valueArrayInts3_2;
		stateSend.m_objectClass.m_ArrayInts[4] = m_valueArrayInts4_2;

		stateSend.m_objectClass.m_Boolean = m_valueBoolean2;


		// Отправляем объект класса.
		pSockSend->Send(&stateSend, sizeSend);

	}
}


void CMFCClassNetworkDlg::OnConnect(BOOL error)
{
	if (error == TRUE)
	{
		CUtil::BeepError();

		MessageBox(L"Попытка подключения была отвергнута!\nВозможно сервер еще не создан!");
	}
	else
	{
		SetWindowText(L"Клиент: сеть работает!");
	}
}


void CMFCClassNetworkDlg::OnBnClickedRadioClient()
{
	UpdateData(TRUE);
	
	if (m_MainSocket.m_hSocket != INVALID_SOCKET)
	{
		CUtil::BeepError();

		int err = WSAGetLastError();
		CString s;
		s.Format(_T("Сокет уже инициализирован\n Error %d"), err);
		MessageBox(s);


		return;
	}

	// Класс CAsyncSocket упрощает процедуру создания сокета,
	// вкладывая в функцию Create() непосредственное создание 
	// сокета и связывание его с одним из IP адресом доступном на компьютере.
	if (m_MainSocket.Create() == TRUE)
	{
		if (m_MainSocket.Connect(m_IP, m_Port) == FALSE)
		{

			// Ресурс временно недоступен.
			// В ассинхронном режиме код этой ошибки
			// считается как ожидание события подключения,
			// т.е. практически успешный возврат.
			// Это когда операция не может быть завершена 
			// немедленно.
			if (GetLastError() == WSAEWOULDBLOCK)
			{
				
			}
			else
			{
				CUtil::BeepError();
			}
		}
	}

}


void CMFCClassNetworkDlg::OnCloseSocket(BOOL error)
{
	if (m_IsServer == TRUE)
	{
		MessageBox(L"Клиент отсоединился!");
	}


	if (m_IsClient == TRUE)
	{
		MessageBox(L"Сервер закрыл соединение!");
	}
}


void CMFCClassNetworkDlg::OnBnClickedButtonClose()
{
	//
	this->EndDialog(0);
}
